<template>
  <div class="forget-page">
    <img class="logo" src="../../assets/logo_1.png" alt="">
    <p class="title">重置密码</p>
    <p class="description" v-if="linkSend && formData.type === 2">我们向您绑定的邮箱发送了一封含有重置密码链接的邮件。请登录邮箱查看，如长时间没有收到邮件，请检查你的垃圾邮件文件夹。</p>
    <p class="description" v-if="linkSend && formData.type === 1">一条包含验证码的信息已发送至你账号 {{formData.name}} 所绑定的手机上</p>
    <div class="verify-body" v-if="linkSend && formData.type === 1">
      <a-form-model ref="codeVerify" :model="formVerify" :rules="verifyRules">
        <a-form-model-item prop="code" ref="code" :autoLink="false">
          <div class="code-button">
            <a-input v-model="formVerify.code" size="large"
                     :maxLength="6"
                     placeholder="验证码"
                     @blur="() => {$refs.code.onFieldBlur()}"
                     @change="() => {$refs.code.onFieldChange()}"></a-input>
            <a-button type="primary"
                      size="large"
                      :loading="codeLoading" @click="verifyCode">重置密码</a-button>
          </div>
        </a-form-model-item>
      </a-form-model>
    </div>
    <a v-if="linkSend && formData.type === 1" style="margin-bottom: 20px" @click="handleDone">{{codeButtonText}}</a>
    <p class="description" v-if="!linkSend">请选择下面的重置方式，并通过输入 Let's Code 用户名重置您的 Let's Code 帐号密码</p>
    <div class="form">
      <a-form-model v-if="!linkSend" ref="form" :model="formData" :rules="formRules">
        <a-form-model-item label="重置方式">
          <a-radio-group v-model="formData.type">
            <a-radio :value="1">手机号</a-radio>
            <a-radio :value="2">邮箱</a-radio>
          </a-radio-group>
        </a-form-model-item>
        <a-form-model-item prop="name">
          <a-input v-model="formData.name" allowClear size="large" placeholder="用户名">
            <a-icon slot="prefix" type="user" style="color:#517E55"/>
          </a-input>
        </a-form-model-item>
        <a-form-model-item>
          <a-button size="large" block :loading="loading" type="primary" @click="handleDone">重置密码</a-button>
        </a-form-model-item>
      </a-form-model>
      <a-button v-else size="large" block type="primary" @click="$router.back()">登录 Let's Code</a-button>
    </div>
  </div>
</template>

<script>
  export default{
    data() {
      let validatorCode = (rule, value, callback) => {
        let reg = /^[0-9]{6}$/
        if (!reg.test(value)) {
          return callback(new Error('验证码格式错误'));
        } else {
          callback()
        }
      }
      let validateName = (rule, value, callback) => {
        if (!value) {
          return callback(new Error('用户名为必填项'));
        } else {
          this.$axios.post('register/user/check',
              {
                name: this.formData.name
              }).then(res => {
            if (res.code == 0) {
              return callback(new Error('用户名不存在'));
            } else {
              callback()
            }
          }).catch(() => {
            return callback(new Error('用户名校验失败'));
          })
        }
      }
      return {
        formData: {
          type: 1,
          name: ""
        },
        formRules: {
          name: [{validator: validateName, trigger: 'blur'}]
        },
        formVerify: {
          code: ""
        },
        verifyRules: {
          code: [
              {required: true, message: '请输入验证码', trigger: 'blur'},
              {validator: validatorCode, trigger: 'blur'}
          ]
        },
        linkSend: false,
        loading: false,
        codeLoading: false,
        codeButtonText: ""
      };
    },

    methods:{
      verifyCode() {
        this.$refs.codeVerify.validate(valid => {
          if (valid) {
            this.$router.push({
              path: '/register/reset_password',
              query: {
                name: this.formData.name,
                check_code: this.formVerify.code
              }
            })
          }
        })
      },

      handleDone() {
        if (this.codeButtonText.includes('秒')) return;
        this.$refs.form.validate(async valid => {
          if (valid) {
            this.loading = true
            await this.$axios.post(this.formData.type === 1 ? 'register/forget_password/sms' : 'register/forget_password', {
              name: this.formData.name
            }).then(res => {
              if (res.code == 0) {
                if (this.formData.type === 1) {
                  let _this = this
                  let count = 59
                  let timerFun = () => {
                    _this.codeTimer = setTimeout(() => {
                      if (count < 0) {
                        _this.codeButtonText = '没有收到验证码？点此重发'
                        clearTimeout(_this.codeTimer)
                      } else {
                        _this.codeButtonText = `${count}秒后可重发`
                      }
                      count--
                      timerFun()
                    }, 1000)
                  }
                  timerFun()
                }
                this.linkSend = true
              } else if (res.code == 501) {
                this.$notification.error({
                  message: res.info
                })
              } else {
                this.$notification.error({
                  message: '密码重置失败'
                })
              }
            }).catch(() => {
              this.$notification.error({
                message: '密码重置失败'
              })
            })
            this.loading = false
          }
        })
      }
    }
  }
</script>

<style lang="less" scoped>
  .forget-page {
    height: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
    padding-top: 100px;
    .logo {
      width: 250px;
      margin-bottom: 30px;
    }
    .title {
      font-weight: bold;
      font-size: 32px;
      margin-bottom: 12px;
    }
    .description {
      width: 600px;
      text-align: center;
      color: #8C92A4;
      margin-bottom: 50px;
    }
    .form {
      width: 300px;
    }
    .verify-body {
      .code-button {
        display: flex;

        /deep/ .ant-input {
          border-top-right-radius: 0px;
          border-bottom-right-radius: 0px;
        }

        /deep/ .ant-btn-lg {
          border-top-left-radius: 0px;
          border-bottom-left-radius: 0px;
        }
      }
    }
  }
</style>
